from axipy import UnitValue, LinearUnits, AxiomaInitLogLevel, init_axioma, provider_manager, Feature

from ru_axioma_gis_add_geo_tools.tools.parallel_linestring.create_parallel import ParamsOffset, TypeOffset, \
    createParallel

app=init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
value_offset=UnitValue(500,LinearUnits.cm)
params=ParamsOffset(value_offset,TypeOffset.DoubleSide)
path_tab=r"E:\Support\AxiomaTesting\Shapely\test_lat_longtab.tab"
tab=provider_manager.openfile(path_tab)
new_ft_out=[]
for ft in tab.items():
    geometry=ft.geometry
    geo_left,geo_right=createParallel(geometry,params)
    new_ft=None
    if geo_left is not None:
        new_ft=Feature(geometry=geo_left)
        new_ft_out.append(new_ft)
    if geo_right is not None:
        new_ft=Feature(geometry=geo_right)
        new_ft_out.append(new_ft)
if len(new_ft_out)>0:
    tab.insert(new_ft_out)
tab.commit()
app.exit()
print("End")