from axipy import Plugin, Position

from ru_axioma_gis_add_geo_tools.tools.line_pairing.tool_pairing import ToolPairing
from ru_axioma_gis_add_geo_tools.tools.orthogonalization.toolOrthogonalize import ToolOrthogonalize
from ru_axioma_gis_add_geo_tools.tools.parallel_linestring.tool_parallel import ToolParallel


class AddGeometryTools(Plugin):
    def __init__(self):
        super().__init__()
        self.__children_tools=[]
        self.__children_tools.append(ToolParallel(self))
        self.__children_tools.append(ToolPairing(self))
        self.__children_tools.append(ToolOrthogonalize(self))
        position = Position('Геометрия', 'Операции')
        for tool in self.__children_tools:
            position.add(tool.action)
    def unload(self) -> None:
        for tool in self.__children_tools:
            tool.unload()
            tool.action.remove()
