from axipy import ListLayers, Map, Table, Schema, Feature


def tabInLayers(layers:ListLayers,tab):
    for layer in layers:
        if isinstance(layer,ListLayers):
            return tabInLayers(layer,tab)
        tab_layer=layer.data_object
        if tab_layer.name==tab.name:
            return layer
    return None
def tabInMap(map:Map,table):
    layrs=map.layers
    return tabInLayers(layrs,table)
def layerEditable(layers:ListLayers):
    for layer in layers:
        if isinstance(layer.data_object,Table) and layer.data_object.is_editable and layer.data_object.is_spatial:
            return True
    return False
def MapExistrEditableLayer(map):
    return layerEditable(map.layers)
def schemaToListAttName(schema:Schema):
    list_att_name=[]
    for att in schema:
        list_att_name.append(att.name)
    return list_att_name
def CloneFeature(ft:Feature,geometry,style):
    att_source=ft.items()
    att_new={}
    for att_s in att_source:
        att_new[att_s[0]]=att_s[1]
    if geometry is not None:
        return Feature(att_new, geometry=geometry, style=style)
    return Feature(att_new,geometry=ft.geometry,style=style)
def compareSchema(table_1:Table,table_2:Table):
    schema_1=table_1.schema
    schema_2=table_2.schema
    att_names_1=schemaToListAttName(schema_1)
    att_names_2=schemaToListAttName(schema_2)
    if len(att_names_1)!=len(att_names_2):
        return False
    set_difference = set(att_names_1) - set(att_names_2)
    list_difference_result = list(set_difference)
    if len(list_difference_result)==0:
        return True
    return False