import os

from PySide2.QtCore import QObject
from PySide2.QtGui import QIcon
from axipy import Plugin, view_manager, ObserverManager, MapView, MapTool

from ru_axioma_gis_add_geo_tools.tools.add_helper.observer_pair_object import factoruObserverForPair
from ru_axioma_gis_add_geo_tools.tools.line_pairing.pairingMapTool import PairingMapTool
from ru_axioma_gis_add_geo_tools.tools.line_pairing.tools.save_params import SaveParamsBevel


class ToolPairing(QObject):
    def __init__(self,parent_plugin:Plugin):

        super().__init__()
        self.__curent_mapView=None
        self.__parent_plugin = parent_plugin
        self.__name = "Скругление/Скос"
        self.__observer = factoruObserverForPair()
        self.__observer_view_map=ObserverManager.ActiveMapView
        local_file_icon_1 = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons',
                                         'line_piering_32x32.png')
        self.__icon_tools = QIcon(local_file_icon_1)
        self.__action=self.__parent_plugin.create_tool(self.__name,on_click=self.createMapTool,enable_on=self.__observer.name,tooltip=self.__name,
 icon=self.__icon_tools )
        self.__observer.changed.connect(self.__testEnableOn)
        if isinstance(view_manager.active,MapView):
            self.__curent_mapView=view_manager.active
        if self.__curent_mapView is not None:
            self.__curent_mapView.editable_layer_changed.connect(self.__change_editable_layer)
        self.__observer_view_map.changed.connect(self.__change_map_view)
    def createMapTool(self) -> MapTool:
       return PairingMapTool(SaveParamsBevel(self.__parent_plugin.get_plugin_data_dir()))
    @property
    def action(self):
        return self.__action
    def unload(self):
        pass
    def __testEnableOn(self):
        jkl=0
    def __change_map_view(self):
        #if self.__curent_mapView is not None:
        #    self.__curent_mapView.editable_layer_changed.disconnect(self.__change_editable_layer)
        if isinstance(view_manager.active,MapView):
            self.__curent_mapView = view_manager.active
            self.__curent_mapView.editable_layer_changed.connect(self.__change_editable_layer)

    def __change_editable_layer(self):
        if self.__curent_mapView.editable_layer is not None:
            self.__observer.value=True
        else:
            self.__observer.value = False
