import os

import axipy
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog

from ru_axioma_gis_add_geo_tools.tools.orthogonalization.orthogonalize_tools import Orthogonalize


class DlgFormOrto(QDialog):
    def __init__(self,parent=None):
        super().__init__(parent)
        self.__run_cls=None
        self.__run_rask=None
        ui_file = os.path.join(os.path.dirname(__file__), "form_orto.ui")
        # Загружаем файл ui
        self.__ui = QUiLoader().load(ui_file, parent)
        self.__ui.pb_run.clicked.connect(self.__run)
        self.__ui.pb_cancel.clicked.connect(self.__cancel)
        self.__ui.finished.connect(self.__cancel)
    def __run(self):
        self.__ui.pb_run.setEnabled(False)
        self.__ui.pb_cancel.setText("Прервать")
        maxAngleChange =self.__ui.db_spin_deviation.value()
        skewTolerance=self.__ui.db_spin_tolerance.value()
        self.__cls_run=Orthogonalize(maxAngleChange,skewTolerance)
        self.__cls_run.change_progress.connect(self.__update_progess_bar)

        def run_process(t: axipy.Task):
            self.__cls_run.run()

        self.__run_task = axipy.Task(run_process)
        self.__run_task.finished.connect(self.__finish_task)
        self.__run_task.start()
    def __cancel(self):
        if self.__run_cls is not None:
            self.__run_cls.setCancel()
        self.__ui.close()
    def __update_progess_bar(self,value):
        self.__ui.progressBar.setValue(value)

    def __finish_task(self):
        self.__ui.pb_run.setEnabled(True)
        self.__ui.pb_cancel.setText("Закрыть")
        self.__cls_run.change_progress.disconnect(self.__update_progess_bar)
        self.__run_rask = None

        self.__run_cls=None
        self.__ui.close()
    def exec_(self):
        self.__ui.show()

