import os

import axipy
from PySide2.QtCore import QObject
from PySide2.QtGui import QIcon

from ru_axioma_gis_add_geo_tools.tools.orthogonalization.dlgForm import DlgFormOrto
from ru_axioma_gis_add_geo_tools.tools.orthogonalization.tools.observerSelectionPolygon import factoryObserver


class ToolOrthogonalize(QObject):
    def __init__(self,parent_plugin):
        self.__parent_plugin = parent_plugin
        self.__name = "ортогонализацию полигонов"

        #self._title = self.tr(self.__name)
        self.__observer = factoryObserver()
        local_file_icon_1 = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons',
                                         'orthogonalpolygon_32x32.png')
        self.__icon_tools = QIcon(local_file_icon_1)
        self.__action = self.__parent_plugin.create_action(title=self.__name,
                                                           icon=local_file_icon_1, on_click=self.__run,
                                                           enable_on=self.__observer.name)

    @property
    def action(self):
        return self.__action

    def __run(self):
        cls_dlg = DlgFormOrto(axipy.mainwindow.widget)
        cls_dlg.exec_()

    def unload(self):
        pass
