import axipy
from axipy import Observer, selection_manager, GeometryClass


def factoryObserver(name="SelectionPolygon")->Observer:
    observer = axipy.observer_manager.get(name)
    if observer is not None:
        return observer
    observer = Observer(name, False)
    def change_selection():
        if selection_manager.count==0:
            observer.value=False
            return
        tab_sel= axipy.data_manager.selection
        if GeometryClass.Polygons in tab_sel.class_geometries():
            observer.value = True
            return
        observer.value = False
    selection_manager.changed.connect(change_selection)
    change_selection()
    return observer