import os

import axipy
from PySide2.QtCore import QObject
from PySide2.QtGui import QIcon

from ru_axioma_gis_add_geo_tools.tools.add_helper.docWidget import addDoc, AxiDocWidget, existDocWidget, DelDocWidget
from ru_axioma_gis_add_geo_tools.tools.add_helper.observer_tool import factoryObserver
from ru_axioma_gis_add_geo_tools.tools.parallel_linestring.form_parallel import FromParallel


class ToolParallel(QObject):
    def __init__(self,parent_plugin):
        super().__init__()
        self.__parent_plugin=parent_plugin
        self.__name = "создание параллельных  линий"
        self.__form_tool = None
        self.__docWidget = None
        self.__params_form=None
        self._title = self.tr(self.__name)
        self.__observer=factoryObserver()
        local_file_icon_1 = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons',
                                         'parallel_32x32.png')
        self.__icon_tools = QIcon(local_file_icon_1)
        self.__action = self.__parent_plugin.create_action(title=self._title,
                                           icon=local_file_icon_1, on_click=self.__run,enable_on=self.__observer.name)
        self.__observer.changed.connect(self.__disable_form)

    @property
    def action(self):
        return self.__action
    def __run(self):
        if self.__form_tool is None:

            self.__form_tool=FromParallel(axipy.mainwindow.widget)
            if self.__params_form is not None:
                self.__form_tool.setParams(self.__params_form)
        if self.__docWidget is None:
            try:

                self.__docWidget = AxiDocWidget(self.__form_tool.widget, self.__name, self.__name,
                                            self.__icon_tools, axipy.view_manager.global_parent)
            except:
                self.__form_tool = FromParallel(axipy.mainwindow.widget)
                if self.__params_form is not None:
                    self.__form_tool.setParams(self.__params_form)
                self.__docWidget = AxiDocWidget(self.__form_tool.widget, self.__name, self.__name,
                                                self.__icon_tools, axipy.view_manager.global_parent)
            self.__docWidget.close_doc.connect(self.__close_doc_widget)
            addDoc(axipy.mainwindow.widget, self.__docWidget)
        else:
            isExist = existDocWidget(axipy.view_manager.global_parent, self.__docWidget)
            if isExist:
                self.__docWidget.setVisible(True)
                self.__docWidget.setFocus()
                self.__docWidget.raise_()
            else:
                self.__docWidget = AxiDocWidget(self.__form_tool.widget, self.__name, self.__name,
                                                self.__icon_tools, axipy.view_manager.global_parent)
                addDoc(axipy.mainwindow.widget, self.__docWidget)
        self.__form_tool.init()
    def __close_doc_widget(self,value,status):
        if not status:
            DelDocWidget(axipy.mainwindow.widget, self.__docWidget)
            self.__docWidget=None

    def __disable_form(self,value):
        if value:
            return
        if self.__form_tool is not None:
            try:
                self.__params_form=self.__form_tool.getParams()
            except:
                pass
            DelDocWidget(axipy.mainwindow.widget, self.__docWidget)
    def unload(self):
        if self.__docWidget is not None:
            DelDocWidget(axipy.mainwindow.widget, self.__docWidget)

